<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* ֱ Խù  ( .. -_-)
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

	$path = realpath(__FILE__);

	if($path)
	{
		$path = str_replace("latest.php","",$path);
	}

	require_once $path."lib/Common.php";
	require_once "lib/String.php";
	require_once "lib/SQL.php";
	require_once "lib/Security.php";
	require_once "lib/Template.php";

	//   
	require_once "constants.php";

	// ¥ ǥ 
	$date_format = parse_ini_file($path."conf/date_format.ini");

	// ֱ Խù Լ
	function print_latest($board_id, $count = 5, $skin = "default", $subject_length = 30, $body_length = 100)
	{
		global $settings, $date_format;

		if(!$board_id)
			alert($settings->messages[no_board]);

		$sql = new SQL($settings);

		// DB 
		$connection = $sql->db->connect($sql->dsn);

		// ASSOC  Fetch mode 
		$connection->setFetchMode(DB_FETCHMODE_ASSOC);

		if(DB::isError($connection))
			alert($connection->getMessage() . " on " . __FILE__ . " line " . __LINE__);

		$board_name = $connection->getOne("select name from " . $settings->prefix . "_board_config where id = " . $board_id);


		$query_state = " from " . $settings->prefix . "_" . $board_id . "_board as board ";

		$query_state .= " left outer join " . $settings->prefix . "_files as file on file.board_id = " . $board_id . " and board.num = file.board_num and file.seq = 0 ";

		$query_state .= " left outer join " . $settings->prefix . "_category as category on board.category = category.num and category.id=" . $board_id;

		$query_state .= " left outer join " . $settings->prefix . "_member as member on board.email = member.email and board.members = '1'";

		// ڵ Select 
		$query = "select board.*, category.label as category_label, file.num as filenum, file.name as filename, file.size as filesize, file.hit as download, file.type as filetype, member.name as member_name, member.homepage as member_homepage" . $query_state;

		$result = $connection->limitQuery($query . " order by board.reg_date desc",0,$count);

		if(DB::isError($result))
			alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

		if(!strstr($skin, ".html"))
			$skin = $skin . ".html";

		$tpl = new Template($settings->skin_path . "_latest_article");

		if(!$tpl->loadTemplatefile($skin,true, true))
			echo $settings->messages[skin_not_exists];

		while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
		{
			if($subject_length > 0 && strlen($row[subject]) > $subject_length)
				$row[subject] = String::cutString($row[subject], $subject_length);
			if($body_length > 0 && strlen($row[subject]) > $body_length)
				$row[body] = String::cutString($row[body], $body_length);

			//  ð Խù ۼ ð  ð(hour)  
			$gtime = (time() - $row[reg_date])/60/60;

			if(date("Ymd", $row[reg_date]) == date("Ymd"))
				$is_today=true;
			else
				$is_today=false;


			$is_new = false;

			// ֱ  ǺϿ  
			if($gtime < $config[latest_standard])
			{
				$is_new = true;
			}
			else if($row[depth] != "0" && $gtime < $config[latest_standard])
			{
				$is_new = true;
			}

			//  ڰ     member ̺ ̸ о
			if($row[members])
			{
				$row[name] = $row[member_name];
				$row[homepage] = $row[member_homepage];
			}

			// ׷  ± 
			$row[subject]=String::removeTags($row[subject]);
			$row[homepage]=String::removeTags($row[homepage]);
			$row[body]=Security::avoidCrack($row[body]);
			$row[email]=String::removeTags($row[email]);
			$row[name]=String::removeTags($row[name]);

			//   
			if(String::isBlank($row[subject]))
				$row[subject] = $settings->messages[nosubject];

			// ũ  
			$row[subject_only] = $row[subject];
			
			// ũ 
			$link = LINK_NAME . "?module=view&id=" . $board_id . "&num=" . $row[num];

			// ۼ κ ó

			// Խù  ũ Ǵ 
			$row[subject] = "<a href=\"" . $link . "\"><font class=subject>" . $row[subject] . "</font></a>";

			// body κ ó
			if (!$row[html])
			{
				$row[body] = String::removeTags($row[body]);
			}

			//   ü  ǹ ü
			$row[body]=str_replace("  ","&nbsp;&nbsp;",$row[body]);
			$row[body]=str_replace("\t","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",$row[body]);			

			$row[body] = nl2br($row[body]);

			foreach($row as $key => $val)
			{
				$tpl->setVariable(strtoupper($key), $val);
			}

			// ¥
			foreach($date_format as $key => $val)
			{
				$tpl->setVariable(strtoupper($key), date($val, $row[reg_date]));
			}

			// ټ ȸ
			if($config[cool_standard] > 0  && $row[hit] >= $config[cool_standard])
			{
				$tpl->touchBlock("cool");
			}

			// ֱ   NEW
			if($is_new)
			{
				$tpl->touchBlock("new");
			}

			//    NEW
			if($is_today)
			{
				$tpl->touchBlock("today");
			}

			if(!PEAR::isError($tpl->setCurrentBlock("article")))
			{

				$tpl->parseCurrentBlock();
			}

			$tpl->setVariable("BOARD_NAME", $board_name);
			$tpl->setVariable("BOARD_ID", $board_id);
		}

		unset($row);
		unset($result);

		$tpl->show();

		unset($tpl);
	}
?>