<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Database function library
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

require_once "lib/pear/DB.php";

class SQL
{
	var $db		;
	var $dsn	= array();
	var $_field_type_path = "";
	var $_field_types		= array();
	var $_prefix	= "";

	/**
     * Return the current DB Type
     *
     * @return string the DB Type
     *
     * @access public
     */

    function getDBType()
    {
		return $this->dsn[phptype];
    }

    /**
     * DBMS    ȯ
     *
	 * @param string $type DBMS 
	 *
     * @return string 
     *
     * @access public
     */
	function getFieldType($type)
	{
		if(!$this->_field_types && $this->dsn[phptype] != "mysql")
			$this->_field_types = parse_ini_file($this->_field_type_path . $this->dsn[phptype] . ".ini");

		switch($this->dsn[phptype])
		{
			//default : MySQL
			case "mysql" :
				return $type;
				break;

			default :
				return $this->_field_types[$type];
		}
	}

    /**
     * ASSOC  Ǿ ִ 迭($field_array) ʵ($keys) ϴ Ű  Ͽ 
     *
	 * @param array $field_array ASSOC  
	 *
	 * @param array $keys Է ̺ ʵ
	 *
     * @return array Է ̺ ʵ شϴ Ű   迭
     *
     * @access public
     */
	function getValidValues($field_array, $keys)
	{
		$values = array();

		$field_keys = array_keys($field_array);
		$result = array_diff($keys, array_diff($keys, $field_keys));

		foreach($result as $key)
		{
			if(@array_key_exists($key, $field_array))
				$values[$key] = trim($field_array[$key]);
		}

		return $values;
	}

    /**
     * SQL ESCAPE  ߰
     *
	 * @param string $str ڿ
	 *
     * @return string SQL ESCAPE ڰ ߰ ڿ
     *
     * @access public
     */
	function addSlashes($str)
	{
		$str = str_replace("%","\%",$str);
		$str = str_replace("'","\'",$str);
		$str = str_replace(".","\.",$str);

		return $str;
	}


    /**
     * SQL ESCAPE  
     *
	 * @param string $str ڿ
	 *
     * @return string SQL ESCAPE ڰ ŵ ڿ
     *
     * @access public
     */

	function stripSlashes($str)
	{
		$str = str_replace("\%","%",$str);
		$str = str_replace("\'","'",$str);
		$str = str_replace("\.",".",$str);
		$str = str_replace("\\\"","\"",$str);
		$str = str_replace("\\\\","\\",$str);

		return $str;
	}

	/**
	 * Constructor
	 *
     * @access public
	 */

	function SQL($setting)
	{
		$this->db		= new DB;
		$this->dsn		= $this->db->parseDSN($setting->dsn);
		$this->_prefix	= $settings->prefix;
		$this->_field_type_path = $settings->path . "lib/sql_field_types/";
	}
}

?>