<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* XML_Tree  Ȯ. XSL ũ ±׿ encoding  .
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
require_once "XML/Tree.php";

class XTree extends XML_Tree
{
	/**
    * XSL Path
    *
    * @var  string
    */
    var $xsl = '';

    /**
    * Character Encoding
    *
    * @var  string
    */
    var $encoding = '';

    /**
    * Constructor
    *
    * @param  string  Filename
    * @param  string  XML Version
    */
    function XTree($encoding = '' , $xsl = '' , $filename = '', $version = '1.0') {
        $this->filename = $filename;
        $this->version  = $version;
		$this->xsl		= $xsl;
		$this->encoding = $encoding;
    }

    /**
    * Get text representation of XML tree.
    *
    * @return  string  XML
    * @access public
    */
    function &get() {
		header("Content-Type:text/xml");

        $out = '<?xml version="' . $this->version . '"';
		if($this->encoding)
			$out .= ' encoding="' . $this->encoding . '"';
		$out .= "?>\n";
		if($this->xsl)
			$out .= '<?xml:stylesheet type="text/xsl" href="' . $this->xsl . "\"?>\n";
        $out .= $this->root->get();

        return $out;
    }

}